package org.bdware.sc.crdt.proxy;

import org.bdware.crdt.register.MVRegister;
import org.bdware.sc.crdt.SharableVarState;

public class MVRegisterProxy extends SharableVar<MVRegister<Object>> {

    public MVRegisterProxy(String varId, String cpId,
            SharableVarState.SharableVarConfiguration conf) {
        super(varId, cpId, conf);
        self = new MVRegister<>(cpId, varId);
    }

    public void write(Object val) {
        MVRegister<Object> delta = self.write(val);
        localDeltaQueue.add(delta);
    }

    public void resolve(Object val) {
        MVRegister<Object> delta = self.resolve();
        localDeltaQueue.add(delta);
    }

    public Object read() {
        return self.read();
    }

    @Override
    protected MVRegister<Object> newEmptyDelta() {
        return new MVRegister<>(null, varId);
    }
}
