package org.bdware.sc.crdt.proxy;

import org.bdware.crdt.set.RWORSet;
import org.bdware.sc.crdt.SharableVarState;

import java.util.Set;

public class RWORSetProxy extends SharableVar<RWORSet<Object>> {
    public RWORSetProxy(String varId, String cpId, SharableVarState.SharableVarConfiguration conf) {
        super(varId, cpId, conf);
        self = new RWORSet<>(cpId, varId);
    }

    public void add(Object val) {
        RWORSet<Object> delta = self.add(val);
        localDeltaQueue.add(delta);
    }

    public void remove(Object val) {
        RWORSet<Object> delta = self.remove(val);
        localDeltaQueue.add(delta);
    }

    public Set<Object> read() {
        return self.read();
    }

    @Override
    protected RWORSet<Object> newEmptyDelta() {
        return new RWORSet<>(null, varId);
    }
}
